Attribute VB_Name = "modProcedimientos"
Option Explicit

Public Sub LeerArchivoINI()
'Lee los datos de inicializacin, del archivo "MakeyFotos.ini"
On Error GoTo ErrorEnLeerArchivoIni
Dim intNumArch As Integer, strCadenaLeida As String, strAux1 As String, strAux2 As String
intNumArch = FreeFile
Open App.Path & "\MakeyFotos.ini" For Input As intNumArch
Input #intNumArch, strCadenaLeida 'Lee el nombre y versin del programa
Input #intNumArch, strCadenaLeida 'Lee strIdioma
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
strIdioma = strAux2
Input #intNumArch, strCadenaLeida 'Lee strConfiguracion
SepararPorDosPuntos strCadenaLeida, strAux1, strConfiguracion
If (strConfiguracion = NombreDeArchivo(strConfiguracion)) Then
  'strConfiguracion no tiene path, por lo tanto le agrega el del programa
  strConfiguracion = App.Path & "\" & strConfiguracion
End If

Close intNumArch
Exit Sub

CargaPorDefectoArchivoINI:
'Establece valores iniciales por defecto (ya que no se encontr MakeyFotos.ini)
MsgBox "No se encontr el archivo de inicializacin, por lo que se utilizarn valores por defecto", vbOKOnly + vbExclamation, "Atencin"
strConfiguracion = "Nueva"
strIdioma = "Espaol"
Close intNumArch
Exit Sub

ErrorEnLeerArchivoIni:
  Select Case Err.Number
    Case 53 'No existe el archivo .ini
      Resume CargaPorDefectoArchivoINI
    Case 62 'El archivo .ini tiene menos lneas que las necesarias
      Resume CargaPorDefectoArchivoINI
    Case Else
      Resume CargaPorDefectoArchivoINI
  End Select
End Sub


Public Sub GuardarArchivoINI()
'Guarda los datos de inicializacin, en "MakeyFotos.ini"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch As Integer

intNumArch = FreeFile
Open App.Path & "\MakeyFotos.ini" For Output As intNumArch
Write #intNumArch, "MakeyFotos, versin: " & App.Major & "." & App.Minor
Write #intNumArch, "Idioma: " & strIdioma
Write #intNumArch, "ltima configuracin: " & strConfiguracion
Close intNumArch
End Sub


Public Sub LeerConfiguracion(strArchivo As String)
'Lee los datos del archivo de configuracin .mkf "strArchivo"
On Error GoTo ErrorEnLeerConfiguracion
Dim intNumArch As Integer, strCadenaLeida As String, strAux1 As String, strAux2 As String, intAux As Integer

intNumArch = FreeFile
Open strArchivo For Input As intNumArch
Input #intNumArch, strCadenaLeida 'Lee la versin (pero no la asigna)
Input #intNumArch, strCadenaLeida 'Lee strConfiguracion (pero no la asigna)
Input #intNumArch, strCadenaLeida 'Lee lngColorDelFondo
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
lngColorDelFondo = Val(strAux2)
Input #intNumArch, strCadenaLeida 'Lee blnUsarRutasRelativas
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnUsarRutasRelativas = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnUsarTamaosOriginales
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnUsarTamaosOriginales = strAux2
Input #intNumArch, strCadenaLeida 'Lee blnMFPregunta
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
blnMFPregunta = strAux2
Input #intNumArch, strCadenaLeida 'Lee intCantidadDeTeclas
SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
intCantidadDeTeclas = Val(strAux2)
For intAux = 1 To intCantidadDeTeclas
  Input #intNumArch, strCadenaLeida 'Lee strTecla(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strTecla(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strImagen(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strImagen(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strSonido(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strSonido(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strImagenRespuestaCorrecta(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strImagenRespuestaCorrecta(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strSonidoRespuestaCorrecta(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strSonidoRespuestaCorrecta(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strImagenRespuestaIncorrecta(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strImagenRespuestaIncorrecta(intAux) = strAux2
  Input #intNumArch, strCadenaLeida 'Lee strSonidoRespuestaIncorrecta(intAux)
  SepararPorDosPuntos strCadenaLeida, strAux1, strAux2
  strSonidoRespuestaIncorrecta(intAux) = strAux2
Next intAux

Close intNumArch
Exit Sub

CargaPorDefectoConfiguracin:
'Establece valores por defecto
strConfiguracion = "Nueva"
lngColorDelFondo = 0
blnUsarRutasRelativas = False
blnUsarTamaosOriginales = False
blnMFPregunta = False
intCantidadDeTeclas = 1

Close intNumArch
Exit Sub

ErrorEnLeerConfiguracion:
  Select Case Err.Number
    Case 53, 76 'No existe el archivo
      Resume CargaPorDefectoConfiguracin
    Case 62 'El archivo tiene menos lneas que las necesarias
      Resume CargaPorDefectoConfiguracin
    Case Else
      Resume CargaPorDefectoConfiguracin
  End Select
End Sub


Public Sub GuardarConfiguracion(strArchivo As String)
'Guarda los datos de configuracin en el archivo .mkf "strArchivo"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intNumArch As Integer, intAux As Integer, intAux2 As Integer
Dim blnVacio As Boolean

'El siguiente bloque revisa si hay teclas vacas desde la ltima para atrs
intAux = intCantidadDeTeclas
blnVacio = (strTecla(intAux) = "")
blnVacio = blnVacio And ((strImagen(intAux) = "") Or (strImagen(intAux) = "(Imagen)"))
blnVacio = blnVacio And ((strSonido(intAux) = "") Or (strSonido(intAux) = "(Sonido)"))
Do While ((blnVacio) And intAux > 1)
  intAux = intAux - 1
  blnVacio = (strTecla(intAux) = "")
  blnVacio = blnVacio And ((strImagen(intAux) = "") Or (strImagen(intAux) = "(Imagen)"))
  blnVacio = blnVacio And ((strSonido(intAux) = "") Or (strSonido(intAux) = "(Sonido)"))
Loop
'Si hay teclas vacas al final pregunta si se las desea eliminar antes de guardar
If (intAux > 1 And intAux < intCantidadDeTeclas) Then
  If (MsgBox("Desde la tecla " & intAux + 1 & ", ninguna tiene asignadas imgenes ni sonidos. Desea eliminarlas al guardar?", vbYesNo + vbQuestion, "Atencin") = vbYes) Then
    For intAux2 = (intAux + 1) To intCantidadDeTeclas
      frmPrincipal.cboTecla.RemoveItem (intAux)
    Next intAux2
    intCantidadDeTeclas = intAux
    If (frmPrincipal.cboTecla.ListCount > (intCantidadDeTeclas - 1)) Then
      frmPrincipal.cboTecla.ListIndex = intCantidadDeTeclas - 1
    End If
  End If
End If

intNumArch = FreeFile
Open strArchivo For Output As intNumArch
Write #intNumArch, "MakeyFotos, versin: " & App.Major & "." & App.Minor
Write #intNumArch, "Configuracin: " & NombreDeArchivo(strConfiguracion)
Write #intNumArch, "Color del fondo: " & lngColorDelFondo
Write #intNumArch, "Usar rutas relativas: " & blnUsarRutasRelativas
Write #intNumArch, "Usar tamaos originales: " & blnUsarTamaosOriginales
Write #intNumArch, "MFPregunta: " & blnMFPregunta
Write #intNumArch, "Cantidad de teclas: " & intCantidadDeTeclas
For intAux = 1 To intCantidadDeTeclas
  Write #intNumArch, "Letra tecla: " & strTecla(intAux)
  If (blnUsarRutasRelativas = True) Then
    Write #intNumArch, "Imagen: " & NombreDeArchivo(strImagen(intAux))
    Write #intNumArch, "Sonido: " & NombreDeArchivo(strSonido(intAux))
    Write #intNumArch, "Imagen respuesta correcta: " & NombreDeArchivo(strImagenRespuestaCorrecta(intAux))
    Write #intNumArch, "Sonido respuesta correcta: " & NombreDeArchivo(strSonidoRespuestaCorrecta(intAux))
    Write #intNumArch, "Imagen respuesta incorrecta: " & NombreDeArchivo(strImagenRespuestaIncorrecta(intAux))
    Write #intNumArch, "Sonido respuesta incorrecta: " & NombreDeArchivo(strSonidoRespuestaIncorrecta(intAux))
  Else
    Write #intNumArch, "Imagen: " & strImagen(intAux)
    Write #intNumArch, "Sonido: " & strSonido(intAux)
    Write #intNumArch, "Imagen respuesta correcta: " & strImagenRespuestaCorrecta(intAux)
    Write #intNumArch, "Sonido respuesta correcta: " & strSonidoRespuestaCorrecta(intAux)
    Write #intNumArch, "Imagen respuesta incorrecta: " & strImagenRespuestaIncorrecta(intAux)
    Write #intNumArch, "Sonido respuesta incorrecta: " & strSonidoRespuestaIncorrecta(intAux)
  End If
Next intAux

Close intNumArch
End Sub


Public Sub SepararPorDosPuntos(strCadena As String, ByRef strPrimeraParte As String, ByRef strSegundaParte As String)
'Devuelve la primera parte de "strCadena", hasta los ":", en "strPrimeraParte", y lo siguiente en "strSegundaParte"
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intPos As Integer
intPos = InStr(strCadena, ":")
If (intPos > 0) Then
  strPrimeraParte = Mid(strCadena, 1, intPos - 1)
  strSegundaParte = Mid(strCadena, intPos + 1, Len(strCadena) - intPos)
  strSegundaParte = Trim(strSegundaParte)
Else
  strPrimeraParte = ""
  strSegundaParte = ""
End If
End Sub


Public Sub ActualizarPantallaSegunValores()
'Modifica lo que aparece en el formulario Principal de acuerdo a los valores de las variables
Rem On Error Resume Next '(Control para comienzo de proc.: quitar el "Rem" antes de compilar; colocar "Rem" al principio de la lnea para depurar)
Dim intAux As Integer

frmPrincipal.txtConfiguracion.Text = strConfiguracion
frmPrincipal.txtConfiguracion.SelStart = 0
frmPrincipal.txtConfiguracion.SelLength = Len(frmPrincipal.txtConfiguracion.Text)

frmPrincipal.lblColorFondo.BackColor = lngColorDelFondo
frmPrincipal.chkRutasRelativas.Value = IIf(blnUsarRutasRelativas, 1, 0)
frmPrincipal.chkUsarTamaosOriginales.Value = IIf(blnUsarTamaosOriginales, 1, 0)

If (blnMFPregunta = True) Then
  frmPrincipal.optMFResponde.Value = False
  frmPrincipal.optMFPregunta.Value = True
  frmPrincipal.fraRespuestaCorrecta.Enabled = True
  frmPrincipal.fraRespuestaIncorrecta.Enabled = True
  frmPrincipal.txtImagenRespuestaCorrecta.Enabled = True
  frmPrincipal.txtSonidoRespuestaCorrecta.Enabled = True
  frmPrincipal.cmdImagenRespuestaCorrecta.Enabled = True
  frmPrincipal.cmdSonidoRespuestaCorrecta.Enabled = True
  frmPrincipal.txtImagenRespuestaIncorrecta.Enabled = True
  frmPrincipal.txtSonidoRespuestaIncorrecta.Enabled = True
  frmPrincipal.cmdImagenRespuestaIncorrecta.Enabled = True
  frmPrincipal.cmdSonidoRespuestaIncorrecta.Enabled = True
Else
  frmPrincipal.optMFResponde.Value = True
  frmPrincipal.optMFPregunta.Value = False
  frmPrincipal.fraRespuestaCorrecta.Enabled = False
  frmPrincipal.fraRespuestaIncorrecta.Enabled = False
  frmPrincipal.txtImagenRespuestaCorrecta.Enabled = False
  frmPrincipal.txtSonidoRespuestaCorrecta.Enabled = False
  frmPrincipal.cmdImagenRespuestaCorrecta.Enabled = False
  frmPrincipal.cmdSonidoRespuestaCorrecta.Enabled = False
  frmPrincipal.txtImagenRespuestaIncorrecta.Enabled = False
  frmPrincipal.txtSonidoRespuestaIncorrecta.Enabled = False
  frmPrincipal.cmdImagenRespuestaIncorrecta.Enabled = False
  frmPrincipal.cmdSonidoRespuestaIncorrecta.Enabled = False
End If

frmPrincipal.cboTecla.Clear
For intAux = 1 To intCantidadDeTeclas
  frmPrincipal.cboTecla.AddItem Trim((Str(intAux)))
Next intAux
frmPrincipal.cboTecla.AddItem ("+")
intTeclaActual = 1
frmPrincipal.cboTecla.ListIndex = 0

frmPrincipal.txtTecla.Text = strTecla(1)
frmPrincipal.txtImagen.Text = NombreDeArchivo(strImagen(1))
If (frmPrincipal.txtImagen.Text = "") Then frmPrincipal.txtImagen.Text = "(Imagen)"
frmPrincipal.txtSonido.Text = NombreDeArchivo(strSonido(1))
If (frmPrincipal.txtSonido.Text = "") Then frmPrincipal.txtSonido.Text = "(Sonido)"
frmPrincipal.txtImagenRespuestaCorrecta.Text = NombreDeArchivo(strImagenRespuestaCorrecta(1))
If (frmPrincipal.txtImagenRespuestaCorrecta.Text = "") Then frmPrincipal.txtImagenRespuestaCorrecta.Text = "(Imagen)"
frmPrincipal.txtSonidoRespuestaCorrecta.Text = NombreDeArchivo(strSonidoRespuestaCorrecta(1))
If (frmPrincipal.txtSonidoRespuestaCorrecta.Text = "") Then frmPrincipal.txtSonidoRespuestaCorrecta.Text = "(Sonido)"
frmPrincipal.txtImagenRespuestaIncorrecta.Text = NombreDeArchivo(strImagenRespuestaIncorrecta(1))
If (frmPrincipal.txtImagenRespuestaIncorrecta.Text = "") Then frmPrincipal.txtImagenRespuestaIncorrecta.Text = "(Imagen)"
frmPrincipal.txtSonidoRespuestaIncorrecta.Text = NombreDeArchivo(strSonidoRespuestaIncorrecta(1))
If (frmPrincipal.txtSonidoRespuestaIncorrecta.Text = "") Then frmPrincipal.txtSonidoRespuestaIncorrecta.Text = "(Sonido)"
End Sub


Public Sub LeerArchivoIdioma(strArchivo As String)
'Lee el texto de todos los elementos visibles y mensajes del programa, del archivo .lng "strArchivo"
On Error GoTo ErrorEnLeerArchivoIdioma
Dim intNumArch As Integer
intNumArch = FreeFile
Open strArchivo For Input As intNumArch

''#traducciones
Input #intNumArch, id_frmPrincipal_caption
Input #intNumArch, id_frmPrincipal_lblConfiguracion
Input #intNumArch, id_frmPrincipal_cmdGuardar
Input #intNumArch, id_frmPrincipal_cmdAbrir
Input #intNumArch, id_frmPrincipal_cmdNueva
Input #intNumArch, id_frmPrincipal_optMFResponde
Input #intNumArch, id_frmPrincipal_optMFPregunta
Input #intNumArch, id_frmPrincipal_lblFondo
Input #intNumArch, id_frmPrincipal_chkRutasRelativas
Input #intNumArch, id_frmPrincipal_chkUsarTamaosOriginales
Input #intNumArch, id_frmPrincipal_lblOpcion
Input #intNumArch, id_frmPrincipal_lblTecla
Input #intNumArch, id_frmPrincipal_fraRespuestaCorrecta
Input #intNumArch, id_frmPrincipal_fraRespuestaIncorrecta
Input #intNumArch, id_frmPrincipal_cmdIdioma
Input #intNumArch, id_frmPrincipal_cmdInformacin
Input #intNumArch, id_frmPrincipal_cmdEjecutar
Input #intNumArch, id_frmPrincipal_MsgBoxHaLlegadoMens
Input #intNumArch, id_frmPrincipal_MsgBoxHaLlegadoTit
Input #intNumArch, id_frmPrincipal_MsgBoxDeseaEliminarMens
Input #intNumArch, id_frmPrincipal_MsgBoxDeseaEliminarTit
Input #intNumArch, id_frmPrincipal_MsgBoxAlCambiarMens
Input #intNumArch, id_frmPrincipal_MsgBoxAlCambiarTit
Input #intNumArch, id_frmPrincipal_MsgBoxNuevaConfiguarcinMens
Input #intNumArch, id_frmPrincipal_MsgBoxNuevaConfiguarcinTit
Input #intNumArch, id_frmPrincipal_MsgBoxSalirMens
Input #intNumArch, id_frmPrincipal_MsgBoxSalirTit
Input #intNumArch, id_frmPrincipal_dlgArchivoAbrirTit
Input #intNumArch, id_frmPrincipal_dlgArchivoAbrirFil
Input #intNumArch, id_frmPrincipal_dlgArchivoGuardarTit
Input #intNumArch, id_frmPrincipal_dlgArchivoGuardarFil
Input #intNumArch, id_frmPrincipal_dlgIdiomaTit
Input #intNumArch, id_frmPrincipal_dlgIdiomaFil
Input #intNumArch, id_frmInformacin_caption
Input #intNumArch, id_frmInformacin_lblTtulo
Input #intNumArch, id_frmInformacin_lblVersin
Input #intNumArch, id_frmInformacin_cmdManual
Input #intNumArch, id_frmInformacin_cmdCerrar
Input #intNumArch, id_frmPantalla_MsgBoxNoExisteMens
Input #intNumArch, id_frmPantalla_MsgBoxNoExisteTit

Close intNumArch
Exit Sub

CargaPorDefectoArchivoIdioma:
'Establece valores por defecto para las variables de idioma (ya que no se encontr el archivo .lng correspondiente)
''#traducciones
id_frmPrincipal_caption = "MakeyFotos"
id_frmPrincipal_lblConfiguracion = "Configuracin:"
id_frmPrincipal_cmdGuardar = "&Guardar"
id_frmPrincipal_cmdAbrir = "&Abrir"
id_frmPrincipal_cmdNueva = "&Nueva"
id_frmPrincipal_optMFResponde = "MF &Responde"
id_frmPrincipal_optMFPregunta = "MF &Pregunta"
id_frmPrincipal_lblFondo = "Color del fondo:"
id_frmPrincipal_chkRutasRelativas = "&Usar rutas relativas"
id_frmPrincipal_chkUsarTamaosOriginales = "U&sar tamaos originales de las imgenes"
id_frmPrincipal_lblOpcion = "&Opcin"
id_frmPrincipal_lblTecla = "&Tecla"
id_frmPrincipal_fraRespuestaCorrecta = " Respuesta correcta a la pregunta "
id_frmPrincipal_fraRespuestaIncorrecta = " Respuesta incorrecta a la pregunta "
id_frmPrincipal_cmdIdioma = "I&dioma"
id_frmPrincipal_cmdInformacin = "&Informacin"
id_frmPrincipal_cmdEjecutar = "&Ejecutar"
id_frmPrincipal_MsgBoxHaLlegadoMens = "Ha llegado al lmite mximo de cantidad de teclas"
id_frmPrincipal_MsgBoxHaLlegadoTit = "Atencin"
id_frmPrincipal_MsgBoxDeseaEliminarMens = "Desea eliminar los valores de esta tecla?"
id_frmPrincipal_MsgBoxDeseaEliminarTit = "Atencin"
id_frmPrincipal_MsgBoxAlCambiarMens = "Al cambiar esta opcin deber guardar la configuracin, volver a abrirla, y recin entonces ejecutarla."
id_frmPrincipal_MsgBoxAlCambiarTit = "Cambio entre rutas relativas y absolutas"
id_frmPrincipal_MsgBoxNuevaConfiguarcinMens = "Desea crear una nueva configuracin con valores por defecto?"
id_frmPrincipal_MsgBoxNuevaConfiguarcinTit = "Crear nueva"
id_frmPrincipal_MsgBoxSalirMens = "Desea salir del programa?"
id_frmPrincipal_MsgBoxSalirTit = "Salir"
id_frmPrincipal_dlgArchivoAbrirTit = "Abrir archivo de configuracin"
id_frmPrincipal_dlgArchivoAbrirFil = "Archivos de MakeyFotos"
id_frmPrincipal_dlgArchivoGuardarTit = "Guardar el archivo de configuracin"
id_frmPrincipal_dlgArchivoGuardarFil = "Archivos de MakeyFotos"
id_frmPrincipal_dlgIdiomaTit = "Seleccione el idioma"
id_frmPrincipal_dlgIdiomaFil = "Archivos de idioma"
id_frmInformacin_caption = "Acerca de MakeyFotos"
id_frmInformacin_lblTtulo = "MakeyFotos"
id_frmInformacin_lblVersin = "Versin "
id_frmInformacin_cmdManual = "&Documentacin"
id_frmInformacin_cmdCerrar = "&Aceptar"
id_frmPantalla_MsgBoxNoExisteMens = "No existe el archivo "
id_frmPantalla_MsgBoxNoExisteTit = "Archivo no encontrado"

Close intNumArch
Exit Sub

ErrorEnLeerArchivoIdioma:
  Select Case Err.Number
    Case 53 'No existe el archivo .lng
      Resume CargaPorDefectoArchivoIdioma
    Case 62 'El archivo .lng tiene menos lneas que las necesarias
      Resume CargaPorDefectoArchivoIdioma
    Case Else
      Resume CargaPorDefectoArchivoIdioma
  End Select
End Sub

